diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-assoc-manager.h ns-3.44/src/wifi/model/wifi-assoc-manager.h
--- ns-3.43/src/wifi/model/wifi-assoc-manager.h	2024-10-09 16:41:10.128656900 -0700
+++ ns-3.44/src/wifi/model/wifi-assoc-manager.h	2025-03-09 16:55:49.799372700 -0700
@@ -20,7 +20,7 @@
 {
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  *
  * Abstract base class for the Association Manager, which manages
  * scanning and association for single link devices and ML discovery
@@ -38,15 +38,15 @@
         /**
          * Constructor.
          *
-         * \param manager a pointer to the Association Manager
+         * @param manager a pointer to the Association Manager
          */
         ApInfoCompare(const WifiAssocManager& manager);
         /**
          * Function call operator. Calls the Compare method of the Association Manager.
          *
-         * \param lhs left hand side ApInfo object
-         * \param rhs right hand side ApInfo object
-         * \return true if the left hand side ApInfo object should be placed before the
+         * @param lhs left hand side ApInfo object
+         * @param rhs right hand side ApInfo object
+         * @return true if the left hand side ApInfo object should be placed before the
          *         right hand side ApInfo object in the sorted list maintained by the
          *         Association Manager, false otherwise
          */
@@ -68,8 +68,8 @@
     };
 
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
@@ -78,7 +78,7 @@
     /**
      * Set the pointer to the STA wifi MAC.
      *
-     * \param mac the pointer to the STA wifi MAC
+     * @param mac the pointer to the STA wifi MAC
      */
     void SetStaWifiMac(Ptr<StaWifiMac> mac);
 
@@ -88,7 +88,7 @@
      * about APs matching the given scanning parameters may be used and scanning
      * not performed.
      *
-     * \param scanParams the scanning parameters
+     * @param scanParams the scanning parameters
      */
     void StartScanning(WifiScanParams&& scanParams);
 
@@ -98,14 +98,14 @@
      *
      * Note that the given ApInfo object is moved to the sorted list of ApInfo objects.
      *
-     * \param apInfo the AP information contained in the received frame
+     * @param apInfo the AP information contained in the received frame
      */
     virtual void NotifyApInfo(const StaWifiMac::ApInfo&& apInfo);
 
     /**
      * Notify that the given link has completed channel switching.
      *
-     * \param linkId the ID of the given link
+     * @param linkId the ID of the given link
      */
     virtual void NotifyChannelSwitched(uint8_t linkId) = 0;
 
@@ -113,9 +113,9 @@
      * Compare two ApInfo objects for the purpose of keeping a sorted list of
      * ApInfo objects.
      *
-     * \param lhs left hand side ApInfo object
-     * \param rhs right hand side ApInfo object
-     * \return true if the left hand side ApInfo object should be placed before the
+     * @param lhs left hand side ApInfo object
+     * @param rhs right hand side ApInfo object
+     * @return true if the left hand side ApInfo object should be placed before the
      *         right hand side ApInfo object in the sorted list of ApInfo objects,
      *         false otherwise
      */
@@ -125,9 +125,9 @@
      * Search the given RNR element for APs affiliated to the same AP MLD as the
      * reporting AP. The search starts at the given Neighbor AP Information field.
      *
-     * \param rnr the given RNR element
-     * \param nbrApInfoId the index of the given Neighbor AP Information field
-     * \return the index of the Neighbor AP Information field and the index of the
+     * @param rnr the given RNR element
+     * @param nbrApInfoId the index of the given Neighbor AP Information field
+     * @return the index of the Neighbor AP Information field and the index of the
      *         TBTT Information field containing the next affiliated AP, if any.
      */
     static std::optional<WifiAssocManager::RnrLinkInfo> GetNextAffiliatedAp(
@@ -138,8 +138,8 @@
      * Find all the APs affiliated to the same AP MLD as the reporting AP that sent
      * the given RNR element.
      *
-     * \param rnr the given RNR element
-     * \return a list containing the index of the Neighbor AP Information field and the index of the
+     * @param rnr the given RNR element
+     * @return a list containing the index of the Neighbor AP Information field and the index of the
      *         TBTT Information field containing all the affiliated APs
      */
     static std::list<WifiAssocManager::RnrLinkInfo> GetAllAffiliatedAps(
@@ -156,7 +156,7 @@
     using SortedList = std::set<StaWifiMac::ApInfo, ApInfoCompare>;
 
     /**
-     * \return a const reference to the sorted list of ApInfo objects.
+     * @return a const reference to the sorted list of ApInfo objects.
      */
     const SortedList& GetSortedList() const;
 
@@ -164,21 +164,21 @@
      * Get a reference to the list of the links to setup with the given AP. This method
      * allows subclasses to modify such a list.
      *
-     * \param apInfo the info about the given AP
-     * \return a reference to the list of the links to setup with the given AP
+     * @param apInfo the info about the given AP
+     * @return a reference to the list of the links to setup with the given AP
      */
     std::list<StaWifiMac::ApInfo::SetupLinksInfo>& GetSetupLinks(const StaWifiMac::ApInfo& apInfo);
 
     /**
-     * \return the scanning parameters.
+     * @return the scanning parameters.
      */
     const WifiScanParams& GetScanParams() const;
 
     /**
      * Check whether the given AP information match the current scanning parameters.
      *
-     * \param apInfo the given AP information
-     * \return whether the given AP information match the current scanning parameters
+     * @param apInfo the given AP information
+     * @return whether the given AP information match the current scanning parameters
      */
     bool MatchScanParams(const StaWifiMac::ApInfo& apInfo) const;
 
@@ -186,16 +186,16 @@
      * Allow subclasses to choose whether the given ApInfo shall be considered
      * and hence inserted in the sorted list of ApInfo objects.
      *
-     * \param apInfo the apInfo object to insert
-     * \return true if the apInfo object can be inserted, false otherwise
+     * @param apInfo the apInfo object to insert
+     * @return true if the apInfo object can be inserted, false otherwise
      */
     virtual bool CanBeInserted(const StaWifiMac::ApInfo& apInfo) const = 0;
     /**
      * Allow subclasses to choose whether the given ApInfo shall be returned or
      * discarded when the STA wifi MAC requests information on the best AP.
      *
-     * \param apInfo the apInfo object to return
-     * \return true if the apInfo object can be returned, false otherwise
+     * @param apInfo the apInfo object to return
+     * @return true if the apInfo object can be returned, false otherwise
      */
     virtual bool CanBeReturned(const StaWifiMac::ApInfo& apInfo) const = 0;
 
@@ -218,7 +218,7 @@
      *                 Beacon/Probe Response received from the best AP, if any
      * \param[out] rnr const reference to the Reduced Neighbor Report Element present
      *                 in the Beacon/Probe Response received from the best AP, if any.
-     * \return whether 11be Multi-Link setup can be established with the current best AP
+     * @return whether 11be Multi-Link setup can be established with the current best AP
      */
     bool CanSetupMultiLink(OptMleConstRef& mle, OptRnrConstRef& rnr);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-bandwidth-filter.cc ns-3.44/src/wifi/model/wifi-bandwidth-filter.cc
--- ns-3.43/src/wifi/model/wifi-bandwidth-filter.cc	2024-10-09 16:41:10.128656900 -0700
+++ ns-3.44/src/wifi/model/wifi-bandwidth-filter.cc	2025-03-09 16:55:49.799372700 -0700
@@ -12,8 +12,8 @@
 #include "wifi-spectrum-phy-interface.h"
 #include "wifi-spectrum-signal-parameters.h"
 
-#include <ns3/boolean.h>
-#include <ns3/spectrum-transmit-filter.h>
+#include "ns3/boolean.h"
+#include "ns3/spectrum-transmit-filter.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-bandwidth-filter.h ns-3.44/src/wifi/model/wifi-bandwidth-filter.h
--- ns-3.43/src/wifi/model/wifi-bandwidth-filter.h	2024-10-09 16:41:10.128656900 -0700
+++ ns-3.44/src/wifi/model/wifi-bandwidth-filter.h	2025-03-09 16:55:49.799372700 -0700
@@ -7,7 +7,7 @@
 #ifndef WIFI_BANDWIDTH_FILTER_H
 #define WIFI_BANDWIDTH_FILTER_H
 
-#include <ns3/spectrum-transmit-filter.h>
+#include "ns3/spectrum-transmit-filter.h"
 
 namespace ns3
 {
@@ -18,18 +18,18 @@
     WifiBandwidthFilter();
 
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
     /**
-     * \brief Ignore the signal being received if it is a Wi-Fi PPDU whose TX band
+     * @brief Ignore the signal being received if it is a Wi-Fi PPDU whose TX band
      *        (including guard bands) does not overlap the current operating channel.
      *
-     * \param params the parameters of the signals being received
-     * \param receiverPhy the SpectrumPhy of the receiver
-     * \return whether the signal being received should be ignored
+     * @param params the parameters of the signals being received
+     * @param receiverPhy the SpectrumPhy of the receiver
+     * @return whether the signal being received should be ignored
      */
 
     bool DoFilter(Ptr<const SpectrumSignalParameters> params,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-default-ack-manager.cc ns-3.44/src/wifi/model/wifi-default-ack-manager.cc
--- ns-3.43/src/wifi/model/wifi-default-ack-manager.cc	2024-10-09 16:41:10.128656900 -0700
+++ ns-3.44/src/wifi/model/wifi-default-ack-manager.cc	2025-03-09 16:55:49.799372700 -0700
@@ -10,6 +10,7 @@
 
 #include "ap-wifi-mac.h"
 #include "ctrl-headers.h"
+#include "gcr-manager.h"
 #include "qos-utils.h"
 #include "wifi-mac-queue.h"
 #include "wifi-mpdu.h"
@@ -292,8 +293,32 @@
 
     if (receiver.IsGroup())
     {
-        NS_ABORT_MSG_IF(!txParams.LastAddedIsFirstMpdu(receiver),
-                        "Unicast frames only can be aggregated");
+        // if the current acknowledgment method (if any) is already BAR_BLOCK_ACK, it will not
+        // change by adding an MPDU
+        if (txParams.m_acknowledgment &&
+            txParams.m_acknowledgment->method == WifiAcknowledgment::BAR_BLOCK_ACK)
+        {
+            return nullptr;
+        }
+        const auto isGcr = IsGcr(m_mac, hdr);
+        NS_ABORT_MSG_IF(!isGcr && !txParams.LastAddedIsFirstMpdu(receiver),
+                        "Unicast frames only can be aggregated if GCR is not used");
+        if (auto apMac = DynamicCast<ApWifiMac>(m_mac);
+            isGcr && apMac->GetGcrManager()->GetRetransmissionPolicyFor(hdr) ==
+                         GroupAddressRetransmissionPolicy::GCR_BLOCK_ACK)
+        {
+            NS_LOG_DEBUG("Request to schedule a GCR Block Ack Request");
+            const auto recipient =
+                apMac->GetGcrManager()->GetIndividuallyAddressedRecipient(receiver);
+            auto acknowledgment = std::make_unique<WifiBarBlockAck>();
+            acknowledgment->blockAckReqTxVector =
+                GetWifiRemoteStationManager()->GetBlockAckTxVector(recipient, txParams.m_txVector);
+            acknowledgment->blockAckTxVector = acknowledgment->blockAckReqTxVector;
+            acknowledgment->barType = BlockAckReqType::GCR;
+            acknowledgment->baType = BlockAckType::GCR;
+            acknowledgment->SetQosAckPolicy(receiver, hdr.GetQosTid(), WifiMacHeader::BLOCK_ACK);
+            return acknowledgment;
+        }
         auto acknowledgment = std::make_unique<WifiNoAck>();
         if (hdr.IsQosData())
         {
@@ -369,6 +394,22 @@
         return acknowledgment;
     }
 
+    if (hdr.IsBlockAckReq())
+    {
+        CtrlBAckRequestHeader baReqHdr;
+        mpdu->GetPacket()->PeekHeader(baReqHdr);
+        if (baReqHdr.IsGcr())
+        {
+            NS_LOG_DEBUG("GCR Block Ack Req, request GCR Block Ack");
+            auto acknowledgment = std::make_unique<WifiBlockAck>();
+            acknowledgment->blockAckTxVector =
+                GetWifiRemoteStationManager()->GetBlockAckTxVector(receiver, txParams.m_txVector);
+            acknowledgment->baType = BlockAckType::GCR;
+            acknowledgment->SetQosAckPolicy(receiver, tid, WifiMacHeader::NORMAL_ACK);
+            return acknowledgment;
+        }
+    }
+
     NS_LOG_DEBUG(
         "A-MPDU using Implicit Block Ack Request policy or BlockAckReq, request Block Ack");
     auto acknowledgment = std::make_unique<WifiBlockAck>();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-default-ack-manager.h ns-3.44/src/wifi/model/wifi-default-ack-manager.h
--- ns-3.43/src/wifi/model/wifi-default-ack-manager.h	2024-10-09 16:41:10.128656900 -0700
+++ ns-3.44/src/wifi/model/wifi-default-ack-manager.h	2025-03-09 16:55:49.799372700 -0700
@@ -18,7 +18,7 @@
 class WifiMpdu;
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  *
  * WifiDefaultAckManager is the default ack manager.
  */
@@ -26,8 +26,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
@@ -45,9 +45,9 @@
      * of the given MPDU and of all the QoS data frames included in the given TX
      * parameters.
      *
-     * \param mpdu the given MPDU
-     * \param txParams the given TX parameters
-     * \return the maximum distance between the starting sequence number of the Block
+     * @param mpdu the given MPDU
+     * @param txParams the given TX parameters
+     * @return the maximum distance between the starting sequence number of the Block
      *         Ack agreement which the given MPDU belongs to and each of the sequence
      *         numbers of the given MPDU and of all the QoS data frames included in
      *         the given TX parameters
@@ -61,15 +61,15 @@
      * included in the given TX parameters requires an immediate response (Normal Ack,
      * Block Ack or Block Ack Request followed by Block Ack).
      *
-     * \param mpdu the given MPDU.
-     * \param txParams the given TX parameters.
-     * \return true if the given PSDU requires an immediate response
+     * @param mpdu the given MPDU.
+     * @param txParams the given TX parameters.
+     * @return true if the given PSDU requires an immediate response
      */
     bool IsResponseNeeded(Ptr<const WifiMpdu> mpdu, const WifiTxParameters& txParams) const;
 
     /**
-     * \param mpdu the given MPDU
-     * \return whether there exist MPDUs with lower sequence number than the given MPDU that are
+     * @param mpdu the given MPDU
+     * @return whether there exist MPDUs with lower sequence number than the given MPDU that are
      * inflight on the same link as the given MPDU
      */
     bool ExistInflightOnSameLink(Ptr<const WifiMpdu> mpdu) const;
@@ -83,9 +83,9 @@
      * This method can only be called if the selected acknowledgment method for DL
      * multi-user frames consists of a sequence of BlockAckReq and BlockAck frames.
      *
-     * \param mpdu the given MPDU
-     * \param txParams the TX parameters describing the current multi-user frame
-     * \return the new acknowledgment method or a null pointer if the acknowledgment method
+     * @param mpdu the given MPDU
+     * @param txParams the TX parameters describing the current multi-user frame
+     * @return the new acknowledgment method or a null pointer if the acknowledgment method
      *         is unchanged
      */
     virtual std::unique_ptr<WifiAcknowledgment> GetAckInfoIfBarBaSequence(
@@ -99,9 +99,9 @@
      * This method can only be called if the selected acknowledgment method for DL
      * multi-user frames consists of a MU-BAR Trigger Frame sent as single-user frame.
      *
-     * \param mpdu the given MPDU
-     * \param txParams the TX parameters describing the current multi-user frame
-     * \return the new acknowledgment method or a null pointer if the acknowledgment method
+     * @param mpdu the given MPDU
+     * @param txParams the TX parameters describing the current multi-user frame
+     * @return the new acknowledgment method or a null pointer if the acknowledgment method
      *         is unchanged
      */
     virtual std::unique_ptr<WifiAcknowledgment> GetAckInfoIfTfMuBar(
@@ -116,9 +116,9 @@
      * multi-user frames consists of MU-BAR Trigger Frames aggregated to the PSDUs of
      * the MU PPDU.
      *
-     * \param mpdu the given MPDU
-     * \param txParams the TX parameters describing the current multi-user frame
-     * \return the new acknowledgment method or a null pointer if the acknowledgment method
+     * @param mpdu the given MPDU
+     * @param txParams the TX parameters describing the current multi-user frame
+     * @return the new acknowledgment method or a null pointer if the acknowledgment method
      *         is unchanged
      */
     virtual std::unique_ptr<WifiAcknowledgment> GetAckInfoIfAggregatedMuBar(
@@ -129,9 +129,9 @@
      * Calculate the acknowledgment method for the TB PPDUs solicited by the given
      * Trigger Frame.
      *
-     * \param mpdu the given Trigger Frame
-     * \param txParams the current TX parameters (just the TXVECTOR needs to be set)
-     * \return the acknowledgment method for the TB PPDUs solicited by the given Trigger Frame
+     * @param mpdu the given Trigger Frame
+     * @param txParams the current TX parameters (just the TXVECTOR needs to be set)
+     * @return the acknowledgment method for the TB PPDUs solicited by the given Trigger Frame
      */
     virtual std::unique_ptr<WifiAcknowledgment> TryUlMuTransmission(
         Ptr<const WifiMpdu> mpdu,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-default-assoc-manager.cc ns-3.44/src/wifi/model/wifi-default-assoc-manager.cc
--- ns-3.43/src/wifi/model/wifi-default-assoc-manager.cc	2024-10-09 16:41:10.128656900 -0700
+++ ns-3.44/src/wifi/model/wifi-default-assoc-manager.cc	2025-03-09 16:55:49.799372700 -0700
@@ -90,9 +90,12 @@
         for (uint8_t linkId = 0; linkId < m_mac->GetNLinks(); linkId++)
         {
             Simulator::Schedule(GetScanParams().probeDelay,
-                                &StaWifiMac::SendProbeRequest,
+                                &StaWifiMac::EnqueueProbeRequest,
                                 m_mac,
-                                linkId);
+                                m_mac->GetProbeRequest(linkId),
+                                linkId,
+                                Mac48Address::GetBroadcast(),
+                                Mac48Address::GetBroadcast());
         }
         m_probeRequestEvent =
             Simulator::Schedule(GetScanParams().probeDelay + GetScanParams().maxChannelTime,
@@ -193,7 +196,7 @@
             Mac48Address bssid = rnr->get().GetBssid(apIt->m_nbrApInfoId, apIt->m_tbttInfoFieldId);
             setupLinks.emplace_back(StaWifiMac::ApInfo::SetupLinksInfo{
                 linkId,
-                rnr->get().GetLinkId(apIt->m_nbrApInfoId, apIt->m_tbttInfoFieldId),
+                rnr->get().GetMldParameters(apIt->m_nbrApInfoId, apIt->m_tbttInfoFieldId).linkId,
                 bssid});
 
             if (needChannelSwitch)
@@ -206,10 +209,10 @@
                 // switch this link to using the channel used by a reported AP (or its primary80
                 // in case the reported AP is using a 160 MHz and the non-AP MLD does not support
                 // 160 MHz operations)
-                if (apChannel.GetTotalWidth() > 80 &&
-                    !phy->GetDevice()->GetVhtConfiguration()->Get160MHzOperationSupported())
+                if (apChannel.GetTotalWidth() > MHz_u{80} &&
+                    !phy->GetDevice()->GetVhtConfiguration()->m_160MHzSupported)
                 {
-                    apChannel = apChannel.GetPrimaryChannel(80);
+                    apChannel = apChannel.GetPrimaryChannel(MHz_u{80});
                 }
 
                 NS_LOG_DEBUG("Switch link " << +linkId << " to using " << apChannel);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-default-assoc-manager.h ns-3.44/src/wifi/model/wifi-default-assoc-manager.h
--- ns-3.43/src/wifi/model/wifi-default-assoc-manager.h	2024-10-09 16:41:10.128656900 -0700
+++ ns-3.44/src/wifi/model/wifi-default-assoc-manager.h	2025-03-09 16:55:49.799372700 -0700
@@ -17,7 +17,7 @@
 class StaWifiMac;
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  *
  * Default wifi Association Manager.
  */
@@ -25,8 +25,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
     WifiDefaultAssocManager();
@@ -53,7 +53,7 @@
      * Take action upon the expiration of the timer set when requesting channel
      * switch on the given link.
      *
-     * \param linkId the ID of the given link
+     * @param linkId the ID of the given link
      */
     void ChannelSwitchTimeout(uint8_t linkId);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-default-gcr-manager.cc ns-3.44/src/wifi/model/wifi-default-gcr-manager.cc
--- ns-3.43/src/wifi/model/wifi-default-gcr-manager.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/wifi/model/wifi-default-gcr-manager.cc	2025-03-09 16:55:49.799372700 -0700
@@ -0,0 +1,57 @@
+/*
+ * Copyright (c) 2023 DERONNE SOFTWARE ENGINEERING
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#include "wifi-default-gcr-manager.h"
+
+#include "ap-wifi-mac.h"
+
+#include "ns3/log.h"
+
+namespace ns3
+{
+
+NS_LOG_COMPONENT_DEFINE("WifiDefaultGcrManager");
+
+NS_OBJECT_ENSURE_REGISTERED(WifiDefaultGcrManager);
+
+TypeId
+WifiDefaultGcrManager::GetTypeId()
+{
+    static TypeId tid = TypeId("ns3::WifiDefaultGcrManager")
+                            .SetParent<GcrManager>()
+                            .SetGroupName("Wifi")
+                            .AddConstructor<WifiDefaultGcrManager>();
+    return tid;
+}
+
+WifiDefaultGcrManager::WifiDefaultGcrManager()
+{
+    NS_LOG_FUNCTION(this);
+}
+
+WifiDefaultGcrManager::~WifiDefaultGcrManager()
+{
+    NS_LOG_FUNCTION_NOARGS();
+}
+
+Mac48Address
+WifiDefaultGcrManager::GetIndividuallyAddressedRecipient(
+    const Mac48Address& /* groupAddress */) const
+{
+    /*
+     * 802.11-2020: 10.23.2.12.2 Unsolicited retry procedure:
+     * When using a protection mechanism that requires a response from another STA,
+     * the AP should select a STA that is a member of the GCR group.
+     * For now, we assume all associated GCR-capable STAs are part of the GCR group,
+     * hence we pick the first STA from the list held by the AP.
+     */
+    NS_ASSERT(!m_staMembers.empty());
+    return *m_staMembers.cbegin();
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-default-gcr-manager.h ns-3.44/src/wifi/model/wifi-default-gcr-manager.h
--- ns-3.43/src/wifi/model/wifi-default-gcr-manager.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/wifi/model/wifi-default-gcr-manager.h	2025-03-09 16:55:49.799372700 -0700
@@ -0,0 +1,45 @@
+/*
+ * Copyright (c) 2023 DERONNE SOFTWARE ENGINEERING
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#ifndef WIFI_DEFAULT_GCR_MANAGER_H
+#define WIFI_DEFAULT_GCR_MANAGER_H
+
+#include "gcr-manager.h"
+
+namespace ns3
+{
+
+/**
+ * @ingroup wifi
+ *
+ * WifiDefaultGcrManager is the default implementation for groupcast with retries GCR, as defined in
+ * 802.11aa. Since the standard does not describe how to map GCR-capable STAs to a given GCR group,
+ * the default implementation assumes all GCR-capable STAs are part of all GCR groups. Also, it is
+ * left left open to implementation which individual address to use to use while protecting a GCR
+ * transmission. The default implementation decides to pick the address of the first associated
+ * GCR-capable STA.
+ */
+class WifiDefaultGcrManager : public GcrManager
+{
+  public:
+    /**
+     * @brief Get the type ID.
+     * @return the object TypeId
+     */
+    static TypeId GetTypeId();
+
+    WifiDefaultGcrManager();
+    ~WifiDefaultGcrManager() override;
+
+    Mac48Address GetIndividuallyAddressedRecipient(
+        const Mac48Address& groupcastAddress) const override;
+};
+
+} // namespace ns3
+
+#endif /* WIFI_DEFAULT_GCR_MANAGER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-default-protection-manager.cc ns-3.44/src/wifi/model/wifi-default-protection-manager.cc
--- ns-3.43/src/wifi/model/wifi-default-protection-manager.cc	2024-10-09 16:41:10.128656900 -0700
+++ ns-3.44/src/wifi/model/wifi-default-protection-manager.cc	2025-03-09 16:55:49.799372700 -0700
@@ -9,12 +9,12 @@
 #include "wifi-default-protection-manager.h"
 
 #include "ap-wifi-mac.h"
-#include "frame-exchange-manager.h"
 #include "sta-wifi-mac.h"
 #include "wifi-mpdu.h"
 #include "wifi-tx-parameters.h"
 
 #include "ns3/boolean.h"
+#include "ns3/eht-frame-exchange-manager.h"
 #include "ns3/emlsr-manager.h"
 #include "ns3/erp-ofdm-phy.h"
 #include "ns3/log.h"
@@ -48,6 +48,12 @@
                           "Initial Control Frame to an EMLSR client).",
                           BooleanValue(false),
                           MakeBooleanAccessor(&WifiDefaultProtectionManager::m_singleRtsPerTxop),
+                          MakeBooleanChecker())
+            .AddAttribute("SkipMuRtsBeforeBsrp",
+                          "If enabled, MU-RTS is not used to protect the transmission of a BSRP "
+                          "Trigger Frame.",
+                          BooleanValue(true),
+                          MakeBooleanAccessor(&WifiDefaultProtectionManager::m_skipMuRtsBeforeBsrp),
                           MakeBooleanChecker());
     return tid;
 }
@@ -206,8 +212,7 @@
     }
 
     // check if CTS-to-Self is needed
-    if (GetWifiRemoteStationManager()->GetUseNonErpProtection() &&
-        GetWifiRemoteStationManager()->NeedCtsToSelf(txParams.m_txVector))
+    if (GetWifiRemoteStationManager()->NeedCtsToSelf(txParams.m_txVector, hdr))
     {
         auto protection = std::make_unique<WifiCtsToSelfProtection>();
         protection->ctsTxVector = GetWifiRemoteStationManager()->GetCtsToSelfTxVector();
@@ -259,10 +264,9 @@
     {
         // we get here if this is the first MPDU for this receiver.
         NS_ABORT_MSG_IF(m_mac->GetTypeOfStation() != AP, "HE APs only can send DL MU PPDUs");
-        auto apMac = StaticCast<ApWifiMac>(m_mac);
         auto modClass = txParams.m_txVector.GetModulationClass();
         auto txWidth = modClass == WIFI_MOD_CLASS_DSSS || modClass == WIFI_MOD_CLASS_HR_DSSS
-                           ? 20
+                           ? MHz_u{20}
                            : txParams.m_txVector.GetChannelWidth();
 
         if (protection != nullptr)
@@ -310,12 +314,12 @@
             }
         }
 
-        // The initial Control frame of frame exchanges shall be sent in the non-HT PPDU or
-        // non-HT duplicate PPDU format using a rate of 6 Mb/s, 12 Mb/s, or 24 Mb/s.
-        // (Sec. 35.3.17 of 802.11be D3.0)
         if (isEmlsrDestination && !isProtected)
         {
-            GetWifiRemoteStationManager()->AdjustTxVectorForIcf(protection->muRtsTxVector);
+            // This MU-RTS is an ICF for some EMLSR client
+            auto ehtFem =
+                StaticCast<EhtFrameExchangeManager>(m_mac->GetFrameExchangeManager(m_linkId));
+            ehtFem->SetIcfPaddingAndTxVector(protection->muRts, protection->muRtsTxVector);
         }
 
         return std::unique_ptr<WifiMuRtsCtsProtection>(protection);
@@ -376,6 +380,10 @@
         (m_sendMuRts && !allProtected && (!m_singleRtsPerTxop || protectedStas.empty())) ||
         isUnprotectedEmlsrDst;
 
+    // if we are sending a BSRP TF and SkipMuRtsBeforeBsrpTf is true, do not use MU-RTS (even in
+    // case of unprotected EMLSR, because the BSRP TF is an ICF)
+    needMuRts = needMuRts && (!m_skipMuRtsBeforeBsrp || !trigger.IsBsrp());
+
     if (!needMuRts)
     {
         // No protection needed
@@ -395,12 +403,11 @@
     {
         protection->muRtsTxVector.SetMode(ErpOfdmPhy::GetErpOfdmRate6Mbps());
     }
-    // The initial Control frame of frame exchanges shall be sent in the non-HT PPDU or
-    // non-HT duplicate PPDU format using a rate of 6 Mb/s, 12 Mb/s, or 24 Mb/s.
-    // (Sec. 35.3.17 of 802.11be D3.0)
     if (isUnprotectedEmlsrDst)
     {
-        GetWifiRemoteStationManager()->AdjustTxVectorForIcf(protection->muRtsTxVector);
+        // This MU-RTS is an ICF for some EMLSR client
+        auto ehtFem = StaticCast<EhtFrameExchangeManager>(m_mac->GetFrameExchangeManager(m_linkId));
+        ehtFem->SetIcfPaddingAndTxVector(protection->muRts, protection->muRtsTxVector);
     }
 
     return protection;
